#!/usr/bin/env python
##################################################
# Gnuradio Python Flow Graph
# Title: Energy Detect
# Generated: Tue Jul  1 13:42:36 2014
##################################################

execfile("/home/trondeau/.grc_gnuradio/energy_detect_tx.py")
from PyQt4 import Qt
from gnuradio import blocks
from gnuradio import channels
from gnuradio import eng_notation
from gnuradio import gr
from gnuradio import qtgui
from gnuradio import zeromq
from gnuradio.eng_option import eng_option
from gnuradio.filter import firdes
from gnuradio.filter import pfb
from optparse import OptionParser
import mymod
import sip
import sys

class energy_detect(gr.top_block, Qt.QWidget):

    def __init__(self):
        gr.top_block.__init__(self, "Energy Detect")
        Qt.QWidget.__init__(self)
        self.setWindowTitle("Energy Detect")
        try:
             self.setWindowIcon(Qt.QIcon.fromTheme('gnuradio-grc'))
        except:
             pass
        self.top_scroll_layout = Qt.QVBoxLayout()
        self.setLayout(self.top_scroll_layout)
        self.top_scroll = Qt.QScrollArea()
        self.top_scroll.setFrameStyle(Qt.QFrame.NoFrame)
        self.top_scroll_layout.addWidget(self.top_scroll)
        self.top_scroll.setWidgetResizable(True)
        self.top_widget = Qt.QWidget()
        self.top_scroll.setWidget(self.top_widget)
        self.top_layout = Qt.QVBoxLayout(self.top_widget)
        self.top_grid_layout = Qt.QGridLayout()
        self.top_layout.addLayout(self.top_grid_layout)

        self.settings = Qt.QSettings("GNU Radio", "energy_detect")
        self.restoreGeometry(self.settings.value("geometry").toByteArray())


        ##################################################
        # Variables
        ##################################################
        self.sps = sps = 4
        self.samp_rate = samp_rate = 1e6
        self.ch3 = ch3 = True
        self.ch2 = ch2 = True
        self.ch1 = ch1 = True
        self.ch0 = ch0 = True
        self.cal = cal = True
        self.arity = arity = 4

        ##################################################
        # Blocks
        ##################################################
        _ch3_check_box = Qt.QCheckBox("Chan3")
        self._ch3_choices = {True: False, False: True}
        self._ch3_choices_inv = dict((v,k) for k,v in self._ch3_choices.iteritems())
        self._ch3_callback = lambda i: Qt.QMetaObject.invokeMethod(_ch3_check_box, "setChecked", Qt.Q_ARG("bool", self._ch3_choices_inv[i]))
        self._ch3_callback(self.ch3)
        _ch3_check_box.stateChanged.connect(lambda i: self.set_ch3(self._ch3_choices[bool(i)]))
        self.top_grid_layout.addWidget(_ch3_check_box, 0,3,1,1)
        _ch2_check_box = Qt.QCheckBox("Chan2")
        self._ch2_choices = {True: False, False: True}
        self._ch2_choices_inv = dict((v,k) for k,v in self._ch2_choices.iteritems())
        self._ch2_callback = lambda i: Qt.QMetaObject.invokeMethod(_ch2_check_box, "setChecked", Qt.Q_ARG("bool", self._ch2_choices_inv[i]))
        self._ch2_callback(self.ch2)
        _ch2_check_box.stateChanged.connect(lambda i: self.set_ch2(self._ch2_choices[bool(i)]))
        self.top_grid_layout.addWidget(_ch2_check_box, 0,2,1,1)
        _ch1_check_box = Qt.QCheckBox("Chan1")
        self._ch1_choices = {True: False, False: True}
        self._ch1_choices_inv = dict((v,k) for k,v in self._ch1_choices.iteritems())
        self._ch1_callback = lambda i: Qt.QMetaObject.invokeMethod(_ch1_check_box, "setChecked", Qt.Q_ARG("bool", self._ch1_choices_inv[i]))
        self._ch1_callback(self.ch1)
        _ch1_check_box.stateChanged.connect(lambda i: self.set_ch1(self._ch1_choices[bool(i)]))
        self.top_grid_layout.addWidget(_ch1_check_box, 0,1,1,1)
        _ch0_check_box = Qt.QCheckBox("Chan0")
        self._ch0_choices = {True: False, False: True}
        self._ch0_choices_inv = dict((v,k) for k,v in self._ch0_choices.iteritems())
        self._ch0_callback = lambda i: Qt.QMetaObject.invokeMethod(_ch0_check_box, "setChecked", Qt.Q_ARG("bool", self._ch0_choices_inv[i]))
        self._ch0_callback(self.ch0)
        _ch0_check_box.stateChanged.connect(lambda i: self.set_ch0(self._ch0_choices[bool(i)]))
        self.top_grid_layout.addWidget(_ch0_check_box, 0,0,1,1)
        self.zeromq_rep_sink_0_6 = zeromq.rep_sink(gr.sizeof_gr_complex, 1, "tcp://127.0.0.1:5557", 100)
        self.zeromq_rep_sink_0_5 = zeromq.rep_sink(gr.sizeof_gr_complex, 1, "tcp://127.0.0.1:5556", 100)
        self.zeromq_rep_sink_0_4 = zeromq.rep_sink(gr.sizeof_gr_complex, 1, "tcp://127.0.0.1:5555", 100)
        self.zeromq_rep_sink_0_3 = zeromq.rep_sink(gr.sizeof_gr_complex, 1, "tcp://127.0.0.1:5554", 100)
        self.zeromq_rep_sink_0_2 = zeromq.rep_sink(gr.sizeof_gr_complex, 1, "tcp://127.0.0.1:5553", 100)
        self.zeromq_rep_sink_0_1 = zeromq.rep_sink(gr.sizeof_gr_complex, 1, "tcp://127.0.0.1:5552", 100)
        self.zeromq_rep_sink_0_0 = zeromq.rep_sink(gr.sizeof_gr_complex, 1, "tcp://127.0.0.1:5551", 100)
        self.zeromq_rep_sink_0 = zeromq.rep_sink(gr.sizeof_gr_complex, 1, "tcp://127.0.0.1:5550", 100)
        self.qtgui_freq_sink_x_0 = qtgui.freq_sink_c(
        	1024, #size
        	firdes.WIN_BLACKMAN_hARRIS, #wintype
        	0, #fc
        	samp_rate, #bw
        	"QT GUI Plot", #name
        	1 #number of inputs
        )
        self.qtgui_freq_sink_x_0.set_update_time(0.10)
        self.qtgui_freq_sink_x_0.set_y_axis(-140, 10)
        self.qtgui_freq_sink_x_0.enable_autoscale(False)
        self.qtgui_freq_sink_x_0.set_fft_average(1.0)
        
        labels = ["", "", "", "", "",
                  "", "", "", "", ""]
        widths = [1, 1, 1, 1, 1,
                  1, 1, 1, 1, 1]
        colors = ["blue", "red", "green", "black", "cyan",
                  "magenta", "yellow", "dark red", "dark green", "dark blue"]
        alphas = [1.0, 1.0, 1.0, 1.0, 1.0,
                  1.0, 1.0, 1.0, 1.0, 1.0]
        for i in xrange(1):
            if len(labels[i]) == 0:
                self.qtgui_freq_sink_x_0.set_line_label(i, "Data {0}".format(i))
            else:
                self.qtgui_freq_sink_x_0.set_line_label(i, labels[i])
            self.qtgui_freq_sink_x_0.set_line_width(i, widths[i])
            self.qtgui_freq_sink_x_0.set_line_color(i, colors[i])
            self.qtgui_freq_sink_x_0.set_line_alpha(i, alphas[i])
        
        self._qtgui_freq_sink_x_0_win = sip.wrapinstance(self.qtgui_freq_sink_x_0.pyqwidget(), Qt.QWidget)
        self.top_layout.addWidget(self._qtgui_freq_sink_x_0_win)
        self.pfb_channelizer_ccf_0 = pfb.channelizer_ccf(
        	  8,
        	  (firdes.low_pass_2(8, 8, 0.5, 0.2, 80, firdes.WIN_BLACKMAN_HARRIS)),
        	  1.0,
        	  100)
        self.pfb_channelizer_ccf_0.set_channel_map(([]))
        	
        self.mymod_user_trigger_0 = mymod.user_trigger()
        self.mymod_energy_detect_0_0_4_0 = mymod.energy_detect()
        self.mymod_energy_detect_0_0_4 = mymod.energy_detect()
        self.mymod_energy_detect_0_0_3 = mymod.energy_detect()
        self.mymod_energy_detect_0_0_2 = mymod.energy_detect()
        self.mymod_energy_detect_0_0_1 = mymod.energy_detect()
        self.mymod_energy_detect_0_0_0 = mymod.energy_detect()
        self.mymod_energy_detect_0_0 = mymod.energy_detect()
        self.mymod_energy_detect_0 = mymod.energy_detect()
        self.energy_detect_tx_0 = energy_detect_tx(
            ch0=ch0,
            ch3=ch3,
            arity=arity,
            ch2=ch2,
            ch1=ch1,
            sps=sps,
        )
        self.channels_channel_model_0 = channels.channel_model(
        	noise_voltage=0.05,
        	frequency_offset=0.0,
        	epsilon=1.0,
        	taps=(1.0, ),
        	noise_seed=0,
        	block_tags=False
        )
        _cal_check_box = Qt.QCheckBox("Calibrate")
        self._cal_choices = {True: True, False: False}
        self._cal_choices_inv = dict((v,k) for k,v in self._cal_choices.iteritems())
        self._cal_callback = lambda i: Qt.QMetaObject.invokeMethod(_cal_check_box, "setChecked", Qt.Q_ARG("bool", self._cal_choices_inv[i]))
        self._cal_callback(self.cal)
        _cal_check_box.stateChanged.connect(lambda i: self.set_cal(self._cal_choices[bool(i)]))
        self.top_grid_layout.addWidget(_cal_check_box, 1,0,1,1)
        self.blocks_throttle_0 = blocks.throttle(gr.sizeof_gr_complex*1, samp_rate,True)
        self.blocks_copy_0_6 = blocks.copy(gr.sizeof_gr_complex*1)
        self.blocks_copy_0_6.set_enabled(False)
        self.blocks_copy_0_5 = blocks.copy(gr.sizeof_gr_complex*1)
        self.blocks_copy_0_5.set_enabled(False)
        self.blocks_copy_0_4 = blocks.copy(gr.sizeof_gr_complex*1)
        self.blocks_copy_0_4.set_enabled(False)
        self.blocks_copy_0_3 = blocks.copy(gr.sizeof_gr_complex*1)
        self.blocks_copy_0_3.set_enabled(False)
        self.blocks_copy_0_2 = blocks.copy(gr.sizeof_gr_complex*1)
        self.blocks_copy_0_2.set_enabled(False)
        self.blocks_copy_0_1 = blocks.copy(gr.sizeof_gr_complex*1)
        self.blocks_copy_0_1.set_enabled(False)
        self.blocks_copy_0_0 = blocks.copy(gr.sizeof_gr_complex*1)
        self.blocks_copy_0_0.set_enabled(False)
        self.blocks_copy_0 = blocks.copy(gr.sizeof_gr_complex*1)
        self.blocks_copy_0.set_enabled(False)

        ##################################################
        # Connections
        ##################################################
        self.connect((self.blocks_throttle_0, 0), (self.channels_channel_model_0, 0))
        self.connect((self.energy_detect_tx_0, 0), (self.blocks_throttle_0, 0))
        self.connect((self.pfb_channelizer_ccf_0, 0), (self.blocks_copy_0, 0))
        self.connect((self.channels_channel_model_0, 0), (self.pfb_channelizer_ccf_0, 0))
        self.connect((self.channels_channel_model_0, 0), (self.qtgui_freq_sink_x_0, 0))
        self.connect((self.pfb_channelizer_ccf_0, 0), (self.mymod_energy_detect_0, 0))
        self.connect((self.pfb_channelizer_ccf_0, 7), (self.mymod_energy_detect_0_0_4_0, 0))
        self.connect((self.pfb_channelizer_ccf_0, 6), (self.mymod_energy_detect_0_0_4, 0))
        self.connect((self.pfb_channelizer_ccf_0, 5), (self.mymod_energy_detect_0_0_3, 0))
        self.connect((self.pfb_channelizer_ccf_0, 4), (self.mymod_energy_detect_0_0_2, 0))
        self.connect((self.pfb_channelizer_ccf_0, 3), (self.mymod_energy_detect_0_0_1, 0))
        self.connect((self.pfb_channelizer_ccf_0, 2), (self.mymod_energy_detect_0_0_0, 0))
        self.connect((self.pfb_channelizer_ccf_0, 1), (self.mymod_energy_detect_0_0, 0))
        self.connect((self.pfb_channelizer_ccf_0, 5), (self.blocks_copy_0_4, 0))
        self.connect((self.pfb_channelizer_ccf_0, 6), (self.blocks_copy_0_5, 0))
        self.connect((self.pfb_channelizer_ccf_0, 7), (self.blocks_copy_0_6, 0))
        self.connect((self.blocks_copy_0_6, 0), (self.zeromq_rep_sink_0_6, 0))
        self.connect((self.blocks_copy_0, 0), (self.zeromq_rep_sink_0, 0))
        self.connect((self.blocks_copy_0_0, 0), (self.zeromq_rep_sink_0_0, 0))
        self.connect((self.blocks_copy_0_1, 0), (self.zeromq_rep_sink_0_1, 0))
        self.connect((self.blocks_copy_0_2, 0), (self.zeromq_rep_sink_0_2, 0))
        self.connect((self.blocks_copy_0_3, 0), (self.zeromq_rep_sink_0_3, 0))
        self.connect((self.blocks_copy_0_4, 0), (self.zeromq_rep_sink_0_4, 0))
        self.connect((self.blocks_copy_0_5, 0), (self.zeromq_rep_sink_0_5, 0))
        self.connect((self.pfb_channelizer_ccf_0, 1), (self.blocks_copy_0_0, 0))
        self.connect((self.pfb_channelizer_ccf_0, 2), (self.blocks_copy_0_1, 0))
        self.connect((self.pfb_channelizer_ccf_0, 3), (self.blocks_copy_0_2, 0))
        self.connect((self.pfb_channelizer_ccf_0, 4), (self.blocks_copy_0_3, 0))

        ##################################################
        # Asynch Message Connections
        ##################################################
        self.msg_connect(self.mymod_user_trigger_0, "trig", self.mymod_energy_detect_0_0, "cal")
        self.msg_connect(self.mymod_user_trigger_0, "trig", self.mymod_energy_detect_0, "cal")
        self.msg_connect(self.mymod_user_trigger_0, "trig", self.mymod_energy_detect_0_0_0, "cal")
        self.msg_connect(self.mymod_user_trigger_0, "trig", self.mymod_energy_detect_0_0_1, "cal")
        self.msg_connect(self.mymod_user_trigger_0, "trig", self.mymod_energy_detect_0_0_2, "cal")
        self.msg_connect(self.mymod_user_trigger_0, "trig", self.mymod_energy_detect_0_0_3, "cal")
        self.msg_connect(self.mymod_user_trigger_0, "trig", self.mymod_energy_detect_0_0_4, "cal")
        self.msg_connect(self.mymod_user_trigger_0, "trig", self.mymod_energy_detect_0_0_4_0, "cal")
        self.msg_connect(self.mymod_energy_detect_0_0_4_0, "det", self.blocks_copy_0_6, "en")
        self.msg_connect(self.mymod_energy_detect_0_0_4, "det", self.blocks_copy_0_5, "en")
        self.msg_connect(self.mymod_energy_detect_0_0_3, "det", self.blocks_copy_0_4, "en")
        self.msg_connect(self.mymod_energy_detect_0_0_2, "det", self.blocks_copy_0_3, "en")
        self.msg_connect(self.mymod_energy_detect_0_0_1, "det", self.blocks_copy_0_2, "en")
        self.msg_connect(self.mymod_energy_detect_0_0_0, "det", self.blocks_copy_0_1, "en")
        self.msg_connect(self.mymod_energy_detect_0_0, "det", self.blocks_copy_0_0, "en")
        self.msg_connect(self.mymod_energy_detect_0, "det", self.blocks_copy_0, "en")

    def closeEvent(self, event):
        self.settings = Qt.QSettings("GNU Radio", "energy_detect")
        self.settings.setValue("geometry", self.saveGeometry())
        event.accept()

    def get_sps(self):
        return self.sps

    def set_sps(self, sps):
        self.sps = sps
        self.energy_detect_tx_0.set_sps(self.sps)

    def get_samp_rate(self):
        return self.samp_rate

    def set_samp_rate(self, samp_rate):
        self.samp_rate = samp_rate
        self.qtgui_freq_sink_x_0.set_frequency_range(0, self.samp_rate)
        self.blocks_throttle_0.set_sample_rate(self.samp_rate)

    def get_ch3(self):
        return self.ch3

    def set_ch3(self, ch3):
        self.ch3 = ch3
        self.energy_detect_tx_0.set_ch3(self.ch3)
        self._ch3_callback(self.ch3)

    def get_ch2(self):
        return self.ch2

    def set_ch2(self, ch2):
        self.ch2 = ch2
        self.energy_detect_tx_0.set_ch2(self.ch2)
        self._ch2_callback(self.ch2)

    def get_ch1(self):
        return self.ch1

    def set_ch1(self, ch1):
        self.ch1 = ch1
        self.energy_detect_tx_0.set_ch1(self.ch1)
        self._ch1_callback(self.ch1)

    def get_ch0(self):
        return self.ch0

    def set_ch0(self, ch0):
        self.ch0 = ch0
        self.energy_detect_tx_0.set_ch0(self.ch0)
        self._ch0_callback(self.ch0)

    def get_cal(self):
        return self.cal

    def set_cal(self, cal):
        self.cal = cal
        self._cal_callback(self.cal)
        self.mymod_user_trigger_0.trigger(self.cal)

    def get_arity(self):
        return self.arity

    def set_arity(self, arity):
        self.arity = arity
        self.energy_detect_tx_0.set_arity(self.arity)

if __name__ == '__main__':
    import ctypes
    import sys
    if sys.platform.startswith('linux'):
        try:
            x11 = ctypes.cdll.LoadLibrary('libX11.so')
            x11.XInitThreads()
        except:
            print "Warning: failed to XInitThreads()"
    parser = OptionParser(option_class=eng_option, usage="%prog: [options]")
    (options, args) = parser.parse_args()
    Qt.QApplication.setGraphicsSystem(gr.prefs().get_string('qtgui','style','raster'))
    qapp = Qt.QApplication(sys.argv)
    tb = energy_detect()
    tb.start()
    tb.show()
    def quitting():
        tb.stop()
        tb.wait()
    qapp.connect(qapp, Qt.SIGNAL("aboutToQuit()"), quitting)
    qapp.exec_()
    tb = None #to clean up Qt widgets
