#!/usr/bin/env python
##################################################
# Gnuradio Python Flow Graph
# Title: Energy Detect Rx
# Generated: Mon Jun 23 11:08:03 2014
##################################################

from PyQt4 import Qt
from gnuradio import eng_notation
from gnuradio import gr
from gnuradio import qtgui
from gnuradio import zeromq
from gnuradio.eng_option import eng_option
from gnuradio.filter import firdes
from optparse import OptionParser
import sip
import sys

class energy_detect_rx(gr.top_block, Qt.QWidget):

    def __init__(self):
        gr.top_block.__init__(self, "Energy Detect Rx")
        Qt.QWidget.__init__(self)
        self.setWindowTitle("Energy Detect Rx")
        try:
             self.setWindowIcon(Qt.QIcon.fromTheme('gnuradio-grc'))
        except:
             pass
        self.top_scroll_layout = Qt.QVBoxLayout()
        self.setLayout(self.top_scroll_layout)
        self.top_scroll = Qt.QScrollArea()
        self.top_scroll.setFrameStyle(Qt.QFrame.NoFrame)
        self.top_scroll_layout.addWidget(self.top_scroll)
        self.top_scroll.setWidgetResizable(True)
        self.top_widget = Qt.QWidget()
        self.top_scroll.setWidget(self.top_widget)
        self.top_layout = Qt.QVBoxLayout(self.top_widget)
        self.top_grid_layout = Qt.QGridLayout()
        self.top_layout.addLayout(self.top_grid_layout)

        self.settings = Qt.QSettings("GNU Radio", "energy_detect_rx")
        self.restoreGeometry(self.settings.value("geometry").toByteArray())


        ##################################################
        # Variables
        ##################################################
        self.samp_rate = samp_rate = 1000000/8

        ##################################################
        # Blocks
        ##################################################
        self.zeromq_req_source_0_6 = zeromq.req_source(gr.sizeof_gr_complex, 1, "tcp://127.0.0.1:5557", 100)
        self.zeromq_req_source_0_5 = zeromq.req_source(gr.sizeof_gr_complex, 1, "tcp://127.0.0.1:5556", 100)
        self.zeromq_req_source_0_4 = zeromq.req_source(gr.sizeof_gr_complex, 1, "tcp://127.0.0.1:5555", 100)
        self.zeromq_req_source_0_3 = zeromq.req_source(gr.sizeof_gr_complex, 1, "tcp://127.0.0.1:5554", 100)
        self.zeromq_req_source_0_2 = zeromq.req_source(gr.sizeof_gr_complex, 1, "tcp://127.0.0.1:5553", 100)
        self.zeromq_req_source_0_1 = zeromq.req_source(gr.sizeof_gr_complex, 1, "tcp://127.0.0.1:5552", 100)
        self.zeromq_req_source_0_0 = zeromq.req_source(gr.sizeof_gr_complex, 1, "tcp://127.0.0.1:5551", 100)
        self.zeromq_req_source_0 = zeromq.req_source(gr.sizeof_gr_complex, 1, "tcp://127.0.0.1:5550", 100)
        self.qtgui_freq_sink_x_0_0_6 = qtgui.freq_sink_c(
        	1024, #size
        	firdes.WIN_BLACKMAN_hARRIS, #wintype
        	0, #fc
        	samp_rate, #bw
        	"QT GUI Plot", #name
        	1 #number of inputs
        )
        self.qtgui_freq_sink_x_0_0_6.set_update_time(0.10)
        self.qtgui_freq_sink_x_0_0_6.set_y_axis(-140, 10)
        self.qtgui_freq_sink_x_0_0_6.enable_autoscale(False)
        self.qtgui_freq_sink_x_0_0_6.set_fft_average(1.0)
        
        labels = ["Ch7", "", "", "", "",
                  "", "", "", "", ""]
        widths = [1, 1, 1, 1, 1,
                  1, 1, 1, 1, 1]
        colors = ["blue", "red", "green", "black", "cyan",
                  "magenta", "yellow", "dark red", "dark green", "dark blue"]
        alphas = [1.0, 1.0, 1.0, 1.0, 1.0,
                  1.0, 1.0, 1.0, 1.0, 1.0]
        for i in xrange(1):
            if len(labels[i]) == 0:
                self.qtgui_freq_sink_x_0_0_6.set_line_label(i, "Data {0}".format(i))
            else:
                self.qtgui_freq_sink_x_0_0_6.set_line_label(i, labels[i])
            self.qtgui_freq_sink_x_0_0_6.set_line_width(i, widths[i])
            self.qtgui_freq_sink_x_0_0_6.set_line_color(i, colors[i])
            self.qtgui_freq_sink_x_0_0_6.set_line_alpha(i, alphas[i])
        
        self._qtgui_freq_sink_x_0_0_6_win = sip.wrapinstance(self.qtgui_freq_sink_x_0_0_6.pyqwidget(), Qt.QWidget)
        self.top_grid_layout.addWidget(self._qtgui_freq_sink_x_0_0_6_win, 2,1,1,1)
        self.qtgui_freq_sink_x_0_0_5 = qtgui.freq_sink_c(
        	1024, #size
        	firdes.WIN_BLACKMAN_hARRIS, #wintype
        	0, #fc
        	samp_rate, #bw
        	"QT GUI Plot", #name
        	1 #number of inputs
        )
        self.qtgui_freq_sink_x_0_0_5.set_update_time(0.10)
        self.qtgui_freq_sink_x_0_0_5.set_y_axis(-140, 10)
        self.qtgui_freq_sink_x_0_0_5.enable_autoscale(False)
        self.qtgui_freq_sink_x_0_0_5.set_fft_average(1.0)
        
        labels = ["Ch6", "", "", "", "",
                  "", "", "", "", ""]
        widths = [1, 1, 1, 1, 1,
                  1, 1, 1, 1, 1]
        colors = ["blue", "red", "green", "black", "cyan",
                  "magenta", "yellow", "dark red", "dark green", "dark blue"]
        alphas = [1.0, 1.0, 1.0, 1.0, 1.0,
                  1.0, 1.0, 1.0, 1.0, 1.0]
        for i in xrange(1):
            if len(labels[i]) == 0:
                self.qtgui_freq_sink_x_0_0_5.set_line_label(i, "Data {0}".format(i))
            else:
                self.qtgui_freq_sink_x_0_0_5.set_line_label(i, labels[i])
            self.qtgui_freq_sink_x_0_0_5.set_line_width(i, widths[i])
            self.qtgui_freq_sink_x_0_0_5.set_line_color(i, colors[i])
            self.qtgui_freq_sink_x_0_0_5.set_line_alpha(i, alphas[i])
        
        self._qtgui_freq_sink_x_0_0_5_win = sip.wrapinstance(self.qtgui_freq_sink_x_0_0_5.pyqwidget(), Qt.QWidget)
        self.top_grid_layout.addWidget(self._qtgui_freq_sink_x_0_0_5_win, 2,0,1,1)
        self.qtgui_freq_sink_x_0_0_4 = qtgui.freq_sink_c(
        	1024, #size
        	firdes.WIN_BLACKMAN_hARRIS, #wintype
        	0, #fc
        	samp_rate, #bw
        	"QT GUI Plot", #name
        	1 #number of inputs
        )
        self.qtgui_freq_sink_x_0_0_4.set_update_time(0.10)
        self.qtgui_freq_sink_x_0_0_4.set_y_axis(-140, 10)
        self.qtgui_freq_sink_x_0_0_4.enable_autoscale(False)
        self.qtgui_freq_sink_x_0_0_4.set_fft_average(1.0)
        
        labels = ["Ch5", "", "", "", "",
                  "", "", "", "", ""]
        widths = [1, 1, 1, 1, 1,
                  1, 1, 1, 1, 1]
        colors = ["blue", "red", "green", "black", "cyan",
                  "magenta", "yellow", "dark red", "dark green", "dark blue"]
        alphas = [1.0, 1.0, 1.0, 1.0, 1.0,
                  1.0, 1.0, 1.0, 1.0, 1.0]
        for i in xrange(1):
            if len(labels[i]) == 0:
                self.qtgui_freq_sink_x_0_0_4.set_line_label(i, "Data {0}".format(i))
            else:
                self.qtgui_freq_sink_x_0_0_4.set_line_label(i, labels[i])
            self.qtgui_freq_sink_x_0_0_4.set_line_width(i, widths[i])
            self.qtgui_freq_sink_x_0_0_4.set_line_color(i, colors[i])
            self.qtgui_freq_sink_x_0_0_4.set_line_alpha(i, alphas[i])
        
        self._qtgui_freq_sink_x_0_0_4_win = sip.wrapinstance(self.qtgui_freq_sink_x_0_0_4.pyqwidget(), Qt.QWidget)
        self.top_grid_layout.addWidget(self._qtgui_freq_sink_x_0_0_4_win, 1,2,1,1)
        self.qtgui_freq_sink_x_0_0_3 = qtgui.freq_sink_c(
        	1024, #size
        	firdes.WIN_BLACKMAN_hARRIS, #wintype
        	0, #fc
        	samp_rate, #bw
        	"QT GUI Plot", #name
        	1 #number of inputs
        )
        self.qtgui_freq_sink_x_0_0_3.set_update_time(0.10)
        self.qtgui_freq_sink_x_0_0_3.set_y_axis(-140, 10)
        self.qtgui_freq_sink_x_0_0_3.enable_autoscale(False)
        self.qtgui_freq_sink_x_0_0_3.set_fft_average(1.0)
        
        labels = ["Ch4", "", "", "", "",
                  "", "", "", "", ""]
        widths = [1, 1, 1, 1, 1,
                  1, 1, 1, 1, 1]
        colors = ["blue", "red", "green", "black", "cyan",
                  "magenta", "yellow", "dark red", "dark green", "dark blue"]
        alphas = [1.0, 1.0, 1.0, 1.0, 1.0,
                  1.0, 1.0, 1.0, 1.0, 1.0]
        for i in xrange(1):
            if len(labels[i]) == 0:
                self.qtgui_freq_sink_x_0_0_3.set_line_label(i, "Data {0}".format(i))
            else:
                self.qtgui_freq_sink_x_0_0_3.set_line_label(i, labels[i])
            self.qtgui_freq_sink_x_0_0_3.set_line_width(i, widths[i])
            self.qtgui_freq_sink_x_0_0_3.set_line_color(i, colors[i])
            self.qtgui_freq_sink_x_0_0_3.set_line_alpha(i, alphas[i])
        
        self._qtgui_freq_sink_x_0_0_3_win = sip.wrapinstance(self.qtgui_freq_sink_x_0_0_3.pyqwidget(), Qt.QWidget)
        self.top_grid_layout.addWidget(self._qtgui_freq_sink_x_0_0_3_win, 1,1,1,1)
        self.qtgui_freq_sink_x_0_0_2 = qtgui.freq_sink_c(
        	1024, #size
        	firdes.WIN_BLACKMAN_hARRIS, #wintype
        	0, #fc
        	samp_rate, #bw
        	"QT GUI Plot", #name
        	1 #number of inputs
        )
        self.qtgui_freq_sink_x_0_0_2.set_update_time(0.10)
        self.qtgui_freq_sink_x_0_0_2.set_y_axis(-140, 10)
        self.qtgui_freq_sink_x_0_0_2.enable_autoscale(False)
        self.qtgui_freq_sink_x_0_0_2.set_fft_average(1.0)
        
        labels = ["Ch3", "", "", "", "",
                  "", "", "", "", ""]
        widths = [1, 1, 1, 1, 1,
                  1, 1, 1, 1, 1]
        colors = ["blue", "red", "green", "black", "cyan",
                  "magenta", "yellow", "dark red", "dark green", "dark blue"]
        alphas = [1.0, 1.0, 1.0, 1.0, 1.0,
                  1.0, 1.0, 1.0, 1.0, 1.0]
        for i in xrange(1):
            if len(labels[i]) == 0:
                self.qtgui_freq_sink_x_0_0_2.set_line_label(i, "Data {0}".format(i))
            else:
                self.qtgui_freq_sink_x_0_0_2.set_line_label(i, labels[i])
            self.qtgui_freq_sink_x_0_0_2.set_line_width(i, widths[i])
            self.qtgui_freq_sink_x_0_0_2.set_line_color(i, colors[i])
            self.qtgui_freq_sink_x_0_0_2.set_line_alpha(i, alphas[i])
        
        self._qtgui_freq_sink_x_0_0_2_win = sip.wrapinstance(self.qtgui_freq_sink_x_0_0_2.pyqwidget(), Qt.QWidget)
        self.top_grid_layout.addWidget(self._qtgui_freq_sink_x_0_0_2_win, 1,0,1,1)
        self.qtgui_freq_sink_x_0_0_1 = qtgui.freq_sink_c(
        	1024, #size
        	firdes.WIN_BLACKMAN_hARRIS, #wintype
        	0, #fc
        	samp_rate, #bw
        	"QT GUI Plot", #name
        	1 #number of inputs
        )
        self.qtgui_freq_sink_x_0_0_1.set_update_time(0.10)
        self.qtgui_freq_sink_x_0_0_1.set_y_axis(-140, 10)
        self.qtgui_freq_sink_x_0_0_1.enable_autoscale(False)
        self.qtgui_freq_sink_x_0_0_1.set_fft_average(1.0)
        
        labels = ["Ch2", "", "", "", "",
                  "", "", "", "", ""]
        widths = [1, 1, 1, 1, 1,
                  1, 1, 1, 1, 1]
        colors = ["blue", "red", "green", "black", "cyan",
                  "magenta", "yellow", "dark red", "dark green", "dark blue"]
        alphas = [1.0, 1.0, 1.0, 1.0, 1.0,
                  1.0, 1.0, 1.0, 1.0, 1.0]
        for i in xrange(1):
            if len(labels[i]) == 0:
                self.qtgui_freq_sink_x_0_0_1.set_line_label(i, "Data {0}".format(i))
            else:
                self.qtgui_freq_sink_x_0_0_1.set_line_label(i, labels[i])
            self.qtgui_freq_sink_x_0_0_1.set_line_width(i, widths[i])
            self.qtgui_freq_sink_x_0_0_1.set_line_color(i, colors[i])
            self.qtgui_freq_sink_x_0_0_1.set_line_alpha(i, alphas[i])
        
        self._qtgui_freq_sink_x_0_0_1_win = sip.wrapinstance(self.qtgui_freq_sink_x_0_0_1.pyqwidget(), Qt.QWidget)
        self.top_grid_layout.addWidget(self._qtgui_freq_sink_x_0_0_1_win, 0,2,1,1)
        self.qtgui_freq_sink_x_0_0_0 = qtgui.freq_sink_c(
        	1024, #size
        	firdes.WIN_BLACKMAN_hARRIS, #wintype
        	0, #fc
        	samp_rate, #bw
        	"QT GUI Plot", #name
        	1 #number of inputs
        )
        self.qtgui_freq_sink_x_0_0_0.set_update_time(0.10)
        self.qtgui_freq_sink_x_0_0_0.set_y_axis(-140, 10)
        self.qtgui_freq_sink_x_0_0_0.enable_autoscale(False)
        self.qtgui_freq_sink_x_0_0_0.set_fft_average(1.0)
        
        labels = ["Ch1", "", "", "", "",
                  "", "", "", "", ""]
        widths = [1, 1, 1, 1, 1,
                  1, 1, 1, 1, 1]
        colors = ["blue", "red", "green", "black", "cyan",
                  "magenta", "yellow", "dark red", "dark green", "dark blue"]
        alphas = [1.0, 1.0, 1.0, 1.0, 1.0,
                  1.0, 1.0, 1.0, 1.0, 1.0]
        for i in xrange(1):
            if len(labels[i]) == 0:
                self.qtgui_freq_sink_x_0_0_0.set_line_label(i, "Data {0}".format(i))
            else:
                self.qtgui_freq_sink_x_0_0_0.set_line_label(i, labels[i])
            self.qtgui_freq_sink_x_0_0_0.set_line_width(i, widths[i])
            self.qtgui_freq_sink_x_0_0_0.set_line_color(i, colors[i])
            self.qtgui_freq_sink_x_0_0_0.set_line_alpha(i, alphas[i])
        
        self._qtgui_freq_sink_x_0_0_0_win = sip.wrapinstance(self.qtgui_freq_sink_x_0_0_0.pyqwidget(), Qt.QWidget)
        self.top_grid_layout.addWidget(self._qtgui_freq_sink_x_0_0_0_win, 0,1,1,1)
        self.qtgui_freq_sink_x_0_0 = qtgui.freq_sink_c(
        	1024, #size
        	firdes.WIN_BLACKMAN_hARRIS, #wintype
        	0, #fc
        	samp_rate, #bw
        	"QT GUI Plot", #name
        	1 #number of inputs
        )
        self.qtgui_freq_sink_x_0_0.set_update_time(0.10)
        self.qtgui_freq_sink_x_0_0.set_y_axis(-140, 10)
        self.qtgui_freq_sink_x_0_0.enable_autoscale(False)
        self.qtgui_freq_sink_x_0_0.set_fft_average(1.0)
        
        labels = ["Ch0", "", "", "", "",
                  "", "", "", "", ""]
        widths = [1, 1, 1, 1, 1,
                  1, 1, 1, 1, 1]
        colors = ["blue", "red", "green", "black", "cyan",
                  "magenta", "yellow", "dark red", "dark green", "dark blue"]
        alphas = [1.0, 1.0, 1.0, 1.0, 1.0,
                  1.0, 1.0, 1.0, 1.0, 1.0]
        for i in xrange(1):
            if len(labels[i]) == 0:
                self.qtgui_freq_sink_x_0_0.set_line_label(i, "Data {0}".format(i))
            else:
                self.qtgui_freq_sink_x_0_0.set_line_label(i, labels[i])
            self.qtgui_freq_sink_x_0_0.set_line_width(i, widths[i])
            self.qtgui_freq_sink_x_0_0.set_line_color(i, colors[i])
            self.qtgui_freq_sink_x_0_0.set_line_alpha(i, alphas[i])
        
        self._qtgui_freq_sink_x_0_0_win = sip.wrapinstance(self.qtgui_freq_sink_x_0_0.pyqwidget(), Qt.QWidget)
        self.top_grid_layout.addWidget(self._qtgui_freq_sink_x_0_0_win, 0,0,1,1)

        ##################################################
        # Connections
        ##################################################
        self.connect((self.zeromq_req_source_0, 0), (self.qtgui_freq_sink_x_0_0, 0))
        self.connect((self.zeromq_req_source_0_0, 0), (self.qtgui_freq_sink_x_0_0_0, 0))
        self.connect((self.zeromq_req_source_0_1, 0), (self.qtgui_freq_sink_x_0_0_1, 0))
        self.connect((self.zeromq_req_source_0_2, 0), (self.qtgui_freq_sink_x_0_0_2, 0))
        self.connect((self.zeromq_req_source_0_3, 0), (self.qtgui_freq_sink_x_0_0_3, 0))
        self.connect((self.zeromq_req_source_0_4, 0), (self.qtgui_freq_sink_x_0_0_4, 0))
        self.connect((self.zeromq_req_source_0_5, 0), (self.qtgui_freq_sink_x_0_0_5, 0))
        self.connect((self.zeromq_req_source_0_6, 0), (self.qtgui_freq_sink_x_0_0_6, 0))


    def closeEvent(self, event):
        self.settings = Qt.QSettings("GNU Radio", "energy_detect_rx")
        self.settings.setValue("geometry", self.saveGeometry())
        event.accept()

    def get_samp_rate(self):
        return self.samp_rate

    def set_samp_rate(self, samp_rate):
        self.samp_rate = samp_rate
        self.qtgui_freq_sink_x_0_0.set_frequency_range(0, self.samp_rate)
        self.qtgui_freq_sink_x_0_0_0.set_frequency_range(0, self.samp_rate)
        self.qtgui_freq_sink_x_0_0_1.set_frequency_range(0, self.samp_rate)
        self.qtgui_freq_sink_x_0_0_2.set_frequency_range(0, self.samp_rate)
        self.qtgui_freq_sink_x_0_0_3.set_frequency_range(0, self.samp_rate)
        self.qtgui_freq_sink_x_0_0_4.set_frequency_range(0, self.samp_rate)
        self.qtgui_freq_sink_x_0_0_5.set_frequency_range(0, self.samp_rate)
        self.qtgui_freq_sink_x_0_0_6.set_frequency_range(0, self.samp_rate)

if __name__ == '__main__':
    import ctypes
    import sys
    if sys.platform.startswith('linux'):
        try:
            x11 = ctypes.cdll.LoadLibrary('libX11.so')
            x11.XInitThreads()
        except:
            print "Warning: failed to XInitThreads()"
    parser = OptionParser(option_class=eng_option, usage="%prog: [options]")
    (options, args) = parser.parse_args()
    Qt.QApplication.setGraphicsSystem(gr.prefs().get_string('qtgui','style','raster'))
    qapp = Qt.QApplication(sys.argv)
    tb = energy_detect_rx()
    tb.start()
    tb.show()
    def quitting():
        tb.stop()
        tb.wait()
    qapp.connect(qapp, Qt.SIGNAL("aboutToQuit()"), quitting)
    qapp.exec_()
    tb = None #to clean up Qt widgets
